/*
 * @author Johannes Loinig, member of the ISAC-team, 
 * Copyright (c) 2005 by Johannes Loinig
 * created Jul 26, 2005 10:59:01 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */

//FIXXME RK 060720 ProblemBrowserDialog does not exist any more
//wirte a new Junit Test for ProblemDialog
package isac.browserdialog;

import isac.bridge.CalcTree;
import isac.bridge.MathEngine;
import isac.interfaces.IToCalc;
import isac.kestore.KEStoreServices;
//import isac.session.XSessionManager;
import isac.useractions.ActionOnUIElement;
import isac.useractions.EUIElement;
import isac.useractions.IUIElement;
import isac.useractions.UserAction;
import isac.useractions.UserActionOnKEStoreID;
import isac.useractions.UserActionOnKEStoreIDAndWSDID;
import isac.util.Formalization;
import isac.util.formulae.Match;
import isac.util.formulae.ProblemID;
import isac.util.parser.FormalizationDigest;
import isac.wsdialog.IWorksheetDialog;

import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author Johannes Loinig
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates3
 */
public class TestProblemBrowserDialog extends TestCase {
	/*
	private int TIMEOUT_ = 20;

    private Formalization formalization_;

    private MathEngine math_engine_;

    private ProblemBrowserDialog problem_browser_dialog_;

    private XSessionManager session_manager_;

    private String session_id_;
    
    MockProblemBrowserFrame mock_browser_frame_;

    protected void setUp() throws Exception {
        super.setUp();
        //load the file of the example,
        //see TestKEStoreServices#testLoadContentMinisubpbl
        KEStoreServices ks = new KEStoreServices("isac/xmldata");
        Vector vec = ks.loadContent("exp", "exp_IsacCore_Tests_7a.xml");
        //parse out the Formalization
        //see TestFormalizationDigest#testParseExplMini
        String xmlstr = (String) vec.firstElement();
        FormalizationDigest fd = new FormalizationDigest();
        formalization_ = fd.parseFormalization((String) xmlstr);

        MathEngine.init("localhost");
        math_engine_ = MathEngine.getMathEngine();

        session_manager_ = XSessionManager.getInstance();
        session_id_ = (String) session_manager_.login("x", "x").elementAt(0);
        problem_browser_dialog_ = (ProblemBrowserDialog) session_manager_
                .getProblemBrowserDialog(session_id_);

        mock_browser_frame_ = new MockProblemBrowserFrame();
        problem_browser_dialog_.registerBrowserFrame(mock_browser_frame_);

        String wsd_id = session_manager_.openWorksheetDialog(session_id_);
        IWorksheetDialog wsd = session_manager_.getWorksheetDialog(wsd_id);
        
        //see isac.bridge.TestSpecify#testMatchRefine
//        CalcTree ct = wsd.getCalcTree(0, formalization_, IWorksheetDialog.STARTFROM_EXAMPLE);
//        ct.startCalculate();
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 1);
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 1);
    }

//    public void testMatchRefine() throws Exception {
//        ProblemID problem_id = new ProblemID();
//        problem_id.addString("e_pblID");
//        UserActionOnKEStoreID user_action = new UserActionOnKEStoreID(
//                IUIElement.UI_PROBLEMBROWSER_SELECTION_CHANGED, problem_id);
//        problem_browser_dialog_.notifyUserAction(user_action);
//        
//    }
    /*
    /**
     * Sends a request for hierarchy to the browser and waits fot
     * the action with the hierarch but does NOT check the content
     * of the hierarch (would be to difficult to check)
     * 
     * @throws Exception
     */
	/*
    public void testRequestForHierarchy() throws Exception {
        UserAction user_action = new UserAction(
        		EUIElement.UI_REQUEST_FOR_HIERARCHY);
        problem_browser_dialog_.notifyUserAction(user_action);
        
        waitForNotNull(mock_browser_frame_.hierarchy_);
        
        assertNotNull("ProblemBrowserDialog does not respond on request for hierarchy",
        		mock_browser_frame_.hierarchy_);
    }
    */
    /**
     * Tests switching to auto match mode off and on
     * 
     * @throws Exception
     */
	/*
    public void testAutoMatchMode() throws Exception {
    	UserAction off_mode_action = new UserAction(
    			EUIElement.UI_PROBLEMBROWSER_AUTO_MATCH_OFF);
    	problem_browser_dialog_.notifyUserAction(off_mode_action);
    	waitForNotNull(mock_browser_frame_.auto_match_mode_off_);
    	assertEquals("ProblemBrowserDialog does not go to auto match mode off.",
    			true,
    			mock_browser_frame_.auto_match_mode_off_.booleanValue());


    	UserAction on_mode_action = new UserAction(
    			EUIElement.UI_PROBLEMBROWSER_AUTO_MATCH_ON);
    	problem_browser_dialog_.notifyUserAction(on_mode_action);
    	waitForNotNull(mock_browser_frame_.auto_match_mode_on_);
    	assertEquals("ProblemBrowserDialog does not go to auto match mode on.",
    			true,
    			mock_browser_frame_.auto_match_mode_on_.booleanValue());
    	
    }
    */
    /**
     * Tests the problem browser dialog if a new probel is selected and the dialog
     * sends a new link for the minibrowser
     * 
     * @throws Exception
     */
	/*
    public void testNewProblemSelected() throws Exception {
    	ProblemID problem_id = new ProblemID();
    	problem_id.addString("e_pblID");
    	UserActionOnKEStoreIDAndWSDID action = 
    		new UserActionOnKEStoreIDAndWSDID(EUIElement.UI_PROBLEMBROWSER_SELECTION_CHANGED,
    				problem_id, null);
    	problem_browser_dialog_.notifyUserAction(action);

    	waitForNotNull(mock_browser_frame_.link_);
    	
    	assertEquals("Received link is not correct",
    			"http://www.ist.tugraz.at/projects/isac/www/kbase/pbl/pbl_1.xml.html",
				mock_browser_frame_.link_);
    }
    /*

    /**
     * Waits until object is not null or timeout
     * 
     * @param object_to_test
     * @param wait_message
     * @throws Exception
     */
	/*
    private void waitForNotNull(final Object object_to_test) throws Exception {
    	int timeout = TIMEOUT_;
        while(object_to_test == null) {
        	System.out.println("Waiting for "+ object_to_test);
        	timeout--;
        	if(timeout-- == 0) {
        		return;
        	}
        	Thread.sleep(1000);
        }
    }
    */
    
}