package isac.gui.browser;

import isac.util.formulae.Context;

public interface IContextChangeListener {

	/**
	 * Method called by the BrowserFrame when ever a 
	 * new context comes from the BrowserDialog.
	 * The Children of the BrowserFrame (currently MiniBrowser and 
	 * the HierarchyPanel) implement this
	 * method and register themselves with the BrowserFrame. 
	 * 
	 * @param new_context
	 */
	public void contextChanged( Context new_context );
	
}
