/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.util;

/**
 * Represents a Node in the example hierarchy.
 * 
 * @author Mario Hochreiter
 * @version 1.0
 *  
 */
public class ExampleNode extends HierarchyNode {

    protected String example_;

    public String getExample() {
        return example_;
    }

    public void setExample(String example) {
        this.example_ = example;
    }
}