package isac.session;

import isac.users.UserManager;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

public class WatchdogThread extends Thread {

	public void run() {
		while (true) {
			try {
				HashMap hm = SessionManager.getInstance().getSessionMap();
				ArrayList<Session> sessions = new ArrayList<Session>(hm
						.values());
				System.out.println("WatchdogDEBUG before:"+SessionManager.getInstance().getSessionMap().size());
				for (int count = 0; count < sessions.size(); count++) {
					try {
						boolean ui_running = sessions.get(count).getIToGUI()
								.isUIRunning();
						if (!ui_running)
							throw new RemoteException("UI is not running");
					} catch (RemoteException e) {
						UserManager.getInstance().logout(sessions.get(count));
					}

				}
				System.out.println("WatchdogDEBUG after:"+SessionManager.getInstance().getSessionMap().size());
				Thread.sleep(300000);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

}
