/*
 * Created on Dec 12, 2003
 */
package isac.useractions;

/**
 * Notification about the user clicking a GUI element.
 * 
 * @author Alan Krempler
 */
public class UserAction implements IUserAction {

    static final long serialVersionUID = 8063023172994979834L;

	/**
     * the identifier for a UserAction ...
     * @see isac.useractions.EUIElement
     */
    private EUIElement id_;
    
    
    /**TOODO remove this, when merged with IUAction*/
    private EUIContext context_ = EUIContext.UI_CONTEXT_NO_CONTEXT;
    
    /**
     * @param id
     *            An integer value describing the action the user requested on
     *            the GUI
     */
    public UserAction(EUIElement id) {
        id_ = id;
    }

    public UserAction(EUIElement id, EUIContext context){
    	id_=id;
    	context_ = context;
    }
    
    public EUIElement getActionID() {
        return id_;
    }
    
    /**TOODO remove this, when merged with IUAction*/
    public EUIContext getContext(){
    	return context_;
    }
    
}