/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Mar 12, 2005 8:55:37 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.users;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * @author Walther Neuper
 * 
 * contains administrative data (and nothing about the dialog !!!) looking
 * forward to be handled elsewhere outside isac
 */
public class UserAdmin extends Properties {

    private String userpath_;

    private String username_;

    public UserAdmin(String userpath, String username) {
        userpath_ = userpath;
        username_ = username;
    }

    //WN050311 just for creation of the first file
    //beware of the fix path !
    public static void main(String[] args) {
        UserAdmin a = new UserAdmin("isac/xmldata/users", "x");
        a.setProperty("firstName", "x-firstName");
        a.setProperty("lastName", "x-lastName");

        String filename = "isac/xmldata/users/x_admin.txt";
        try {
            FileOutputStream propOutFile = new FileOutputStream(filename);
            a.store(propOutFile, "administrative data of user 'x'");

        } catch (IOException e) {
            System.err.println("I/O failed.");
        }

    }

}