/*
 * @author Georg Kompacher, member of the ISAC-team, 
 * Copyright (c) 2006 by Georg Kompacher
 * created 18.07.2006 12:16:46
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;

import java.io.Serializable;

public class Reference implements Serializable{

	/**
	 * For serialization, see corresponding API Documentation; value generated
	 * by eclipse to avoid a warning
	 */
	private static final long serialVersionUID = 6151920437669144647L;

	private String tag_;
	
	private String id_;
	
	private KEStoreKey kestore_key_;
	
	public String getTag() {
		return tag_;
	}
	
	public String getID() {
		return id_;
	}
	
	public KEStoreKey getKEStoreKey() {
		return kestore_key_;
	}
	
	public void setTag(String tag) {
		this.tag_ = tag;
	}
	
	public void setID(String id) {
		this.id_ = id;
	}
	
	public void setKEStoreKey(KEStoreKey kestore_key) {
		this.kestore_key_ = kestore_key;
	}
}
