/*
 * @author Richard Gradischnegg
 * Created on Jun 25, 2004
 */
package isac.util.tactics;

/**
 * @author Richard Gradischnegg
 */
public class RewriteInst extends Tactic {
    String variable, value;

    Theorem theorem;

    public RewriteInst() {
    }

    public String toSMLString() {
        return name_ + " ([\"(" + variable + "," + value + ")\"],"
                + theorem.toSMLString() + ")";
    }

    /**
     * @return
     */
    public String getValue() {
        return value;
    }

    /**
     * @return
     */
    public String getVariable() {
        return variable;
    }

    /**
     * @param string
     */
    public void setValue(String string) {
        value = string;
    }

    /**
     * @param string
     */
    public void setVariable(String string) {
        variable = string;
    }

    /**
     * @return
     */
    public Theorem getTheorem() {
        return theorem;
    }

    /**
     * @param theorem
     */
    public void setTheorem(Theorem theorem) {
        this.theorem = theorem;
    }

}