/*
 * @author Richard Gradischnegg
 * Created on Oct 14, 2003
 */
package isac.util.tactics;

/**
 * @author Richard Gradischnegg
 */
public class RewriteSet extends Tactic {
    private String ruleSet;

    public RewriteSet() {
    }

    public RewriteSet(String name) {
        this.name_ = name;
    }

    public RewriteSet(String name, String ruleSet) {
        this.name_ = name;
        this.ruleSet = ruleSet;
    }

    public String getName() {
        return name_;
    }

    public void setRuleSet(String ruleSet) {
        this.ruleSet = ruleSet;
    }

    public String getRuleSet() {
        return this.ruleSet;
    }

    public String toSMLString() {
        return name_ + " \"" + ruleSet + "\"";
    }
}