/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 2:35:22 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util;

import isac.session.TestUserManager;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author Walther Neuper Sep 7, 2004, 2:35:22 PM
 * @
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("---isac.util.Testall");
		TestSuite suite = new TestSuite("isac.util.Testall");
		
		//call tests from subdirectories
		suite.addTest(isac.util.formulae.Testall.suite());
		suite.addTest(isac.util.parser.Testall.suite());
		suite.addTest(isac.util.tactics.Testall.suite());
		suite.addTest(isac.util.users.Testall.suite());
		suite.addTest(isac.util.genhtml.Testall.suite());
		
		suite.addTestSuite(TestKEStoreCommunication.class);
		
		return suite;
	}
}
