/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Oct 1, 2004, 10:05:38 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.formulae;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Description of class
 * 
 * @link fully.qualified.Calss#method(fully.qualified.Param)
 * @author Walther Neuper Oct 1, 2004, 10:05:38 AM
 * @version 1.0
 * @see <fully.qualified.Calssname#methodName(param-classes)>
 * @deprecated <if applicable write reason here, otherwise omit this line> @
 */
public class Testall extends TestCase {

    public static Test suite() {
        System.out.println("---isac.util.formulae.Testall");
        TestSuite suite = new TestSuite("isac.util.formulae.Testall");

        //tests in this directory
        suite.addTestSuite(isac.util.formulae.TestCalcHead.class);
        suite.addTestSuite(isac.util.formulae.TestCalcHeadCompoundID.class);
        suite.addTestSuite(isac.util.formulae.TestModel.class);
        suite.addTestSuite(isac.util.formulae.TestPosition.class);
        suite.addTestSuite(isac.util.formulae.TestContextProblem.class);
        suite.addTestSuite(isac.util.formulae.TestContextTheory.class);
        suite.addTestSuite(isac.util.formulae.TestContextMethod.class);

        //tests in subdirectories
        //...

        return suite;
    }
}