/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 3, 2004, 5:28:36 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.parser;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

import isac.util.Formalization;
import isac.util.parser.FormalizationDigest;

/**
 * @author Walther Neuper Sep 3, 2004, 5:28:36 PM
 * gets by ObjectInputStream from 
 * "isac/src/java-tests/isac/kestore/data/exp", "exp_IsacCore_Tests_1b.fmz"
 * 
 * 3.9.04 NOT YET USED
 **/
public class MockFormalizationDigest extends FormalizationDigest {

	public MockFormalizationDigest() {
		super();
	}
	// FIXME should be: (thus mocking doesn't make sense here !!!!!!!!!!
	//     Formalization parseFormalization((String) xmlstr);
	public Formalization parseFormalization (String path, String file) {
		Formalization test = null;		
		File f = new File(path,file);
		try {												
			ObjectInputStream ois = new ObjectInputStream(new FileInputStream(f));
			test = (Formalization) ois.readObject();
			ois.close();			
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} 
		return test;
	}

}
