/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper
 * created Jun 26, 2005 2:05:56 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.tactics;

import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author neuper
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TestTactic extends TestCase {

    /**
     * generate some Tactic's
     */
    public void testTactics() throws Exception {
        System.out.println("---BEGIN isac.util.tactics.TestTactic#testTactics");

        Vector keylist = new Vector();
        keylist.add("normalize");
        keylist.add("polynomial");
        keylist.add("univariate");
        keylist.add("equation");
        Tactic tac = new StringListTactic("Specify_Problem", keylist);
        assertEquals("Specify_Problem [\"normalize\",\"polynomial\","
                + "\"univariate\",\"equation\"]", tac.toSMLString());

        System.out.println("---END isac.util.tactics.TestTactic#testTactics");
    }
}