/****************************************************************** 
* Copyright (c) 2003, Mario Hochreiter, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui;

import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * View for the <code>Tactic</code> object.
 * 
 * @author Mario Hochreiter
 * @version 1.0 25/11/2003
 *
 */
public class TacticPanel extends JPanel {
  public JTextField tacticField;
  
  /**
   * Panel where a tactic can be entered in string representation.
   */
  public TacticPanel() {
    tacticField = new JTextField();
    tacticField.setEditable(false);
    this.add(tacticField);
  }
  
  public void setText(String s) {
    tacticField.setText(s);
    this.validate();
  }
}
