/*
 * Created on Dec 12, 2003
 */
package isac.useractions;

import java.io.Serializable;


/**
 * Interface common to notifications about user interaction
 * TOODO Merge this with IUIAction
 * 
 * @see IUIAction for reverse direction (Dialog --> GUI)
 * 
 * @author Alan Krempler
 */
public interface IUserAction extends Serializable {
	
	/**
	 * @return An integer value describing the action the user requested on the GUI
	 */
	EUIElement getActionID();
	
	/**
	 * required for handling in actionPerformed for various swing components
	 */
	EUIContext getContext();
		
}
