/*
 * @author Richard Gradischnegg
 * Created on Oct 10, 2003
 */
package isac.util.tactics;


/**
 * @author Richard Gradischnegg
 */
public class RewriteSetInst extends Tactic {
  
  String ruleSet, variable, value;
  
  public RewriteSetInst() {			
  }
  
  public RewriteSetInst(String name) {
    this.name_ = name;
  }

  public String getName() {
    return name_;
  }

  public String toSMLString() {
    return name_+" ([\"("+variable+","+value+")\"], \""+ruleSet+"\")";
  }
  
  
  /**
   * @return
   */
  public String getRuleSet() {
    return ruleSet;
  }

  /**
   * @return
   */
  public String getValue() {
    return value;
  }

  /**
   * @return
   */
  public String getVariable() {
    return variable;
  }

  /**
   * @param string
   */
  public void setRuleSet(String string) {
    ruleSet = string;
  }

  /**
   * @param string
   */
  public void setValue(String string) {
    value = string;
  }

  /**
   * @param string
   */
  public void setVariable(String string) {
    variable = string;
  }

}
