/*
 * @author Richard Gradischnegg
 * Created on Nov 13, 2003
 */
package isac.util.tactics;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author Richard Gradischnegg
 */
public class SubProblemTactic extends Tactic {

    private String theoryID;

    private Vector problemID = new Vector();

    public SubProblemTactic() {
    }

    public void addProblemString(String string) {
        this.problemID.add(string);
    }

    public String toSMLString() {
        StringBuffer sb = new StringBuffer();
        sb.append(name_ + " (\"" + theoryID + "\", [");
        Iterator it = problemID.iterator();
        while (it.hasNext()) {
            sb.append("\"" + it.next() + "\",");
        }
        sb.deleteCharAt(sb.length() - 1); // remove last ","
        sb.append("])");
        return sb.toString();
    }

    public Vector getProblemID() {
        return problemID;
    }

    public String getTheoryID() {
        return theoryID;
    }

    public void setProblemID(Vector vector) {
        problemID = vector;
    }

    public void setTheoryID(String string) {
        theoryID = string;
    }
}