(* Algebra Einf"uhrung, Unterrichtsversuch IMST-Projekt
   author: Walther Neuper 2007
   (c) due to copyright terms

use"IsacKnowledge/AlgEin.ML";
use"AlgEin.ML";

remove_thy"Typefix";
remove_thy"AlgEin";
use_thy"IsacKnowledge/Isac";
*)

(** interface isabelle -- isac **)

theory' := overwritel (!theory', [("AlgEin.thy",AlgEin.thy)]);

(** problems **)

store_pbt
 (prep_pbt AlgEin.thy "pbl_algein" [] e_pblID
 (["Berechnung"], [], e_rls, None, 
  []));
(* WN070405
store_pbt
 (prep_pbt AlgEin.thy "pbl_algein_num" [] e_pblID
 (["numerische", "Berechnung"],
  [("#Given" ,["KantenUnten u_", "KantenSenkrecht s_", "KantenOben o_"]),
   ("#Find"  ,["GesamtLaenge l_"])
  ],
  append_rls "e_rls" e_rls [], 
  None, 
  []));
*)
store_pbt
 (prep_pbt AlgEin.thy "pbl_algein_numsym" [] e_pblID
 (["numerischSymbolische", "Berechnung"],
  [("#Given" ,["KantenLaenge k_","Querschnitt q__"(*q_ in Biegelinie.thy*),
	       "KantenUnten u_", "KantenSenkrecht s_", "KantenOben o_"]),
   ("#Find"  ,["GesamtLaenge l_"])
  ],
  e_rls, 
  None, 
  [["Berechnung","erstNumerisch"],["Berechnung","erstSymbolisch"]]));

(* show_ptyps();
   *)


(** methods **)

store_met
    (prep_met AlgEin.thy "met_algein" [] e_metID
	      (["Berechnung"],
	       [],
	       {rew_ord'="tless_true", rls'= Erls, calc = [], 
		srls = Erls, prls = Erls,
		crls =Erls , nrls = Erls},
"empty_script"
));

store_met
    (prep_met AlgEin.thy "met_algein_numsym" [] e_metID
	      (["Berechnung","erstNumerisch"],
	       [],
	       {rew_ord'="tless_true", rls'= Erls, calc = [], 
		srls = Erls, prls = Erls,
		crls =Erls , nrls = Erls},
"empty_script"
));

store_met
    (prep_met AlgEin.thy "met_algein_numsym" [] e_metID
	      (["Berechnung","erstNumerisch"],
	       [("#Given" ,["KantenLaenge k_","Querschnitt q__",
			    "KantenUnten u_", "KantenSenkrecht s_", 
			    "KantenOben o_"]),
		("#Find"  ,["GesamtLaenge l_"])
		],
	       {rew_ord'="tless_true", rls'= e_rls, calc = [], 
		srls = append_rls "srls_..Berechnung-erstSymbolisch" e_rls 
				  [Calc ("Atools.boollist2sum",
					 eval_boollist2sum "")], 
		prls = e_rls, crls =e_rls , nrls = norm_Rational},
"Script RechnenSymbolScript (k_::bool) (q__::bool)           \
\(u_::bool list) (s_::bool list) (o_::bool list) (l_::real) =\
\ (let t_ = Take (l_ = oben + senkrecht + unten);            \
\      sum_ = boollist2sum o_;\
\      t_ = Substitute [oben = sum_] t_;\
\      t_ = Substitute o_ t_;\
\      t_ = Substitute [k_, q__] t_;\
\      t_ = (Repeat (Try (Rewrite_Set norm_Rational False))) t_;\
\      sum_ = boollist2sum s_;\
\      t_ = Substitute [senkrecht = sum_] t_;\
\      t_ = Substitute s_ t_;\
\      t_ = Substitute [k_, q__] t_;\
\      t_ = (Repeat (Try (Rewrite_Set norm_Rational False))) t_;\
\      sum_ = boollist2sum u_;\
\      t_ = Substitute [unten = sum_] t_;\
\      t_ = Substitute u_ t_;\
\      t_ = Substitute [k_, q__] t_;\
\      t_ = (Repeat (Try (Rewrite_Set norm_Rational False))) t_\
\ in (Try (Rewrite_Set norm_Rational False)) t_)"
));

store_met
    (prep_met AlgEin.thy "met_algein_symnum" [] e_metID
	      (["Berechnung","erstSymbolisch"],
	       [("#Given" ,["KantenLaenge k_","Querschnitt q__",
			    "Kantenunten u_", "Kantensenkrecht s_", 
			    "Kantenoben o_"]),
		("#Find"  ,["GesamtLaenge l_"])
		],
	       {rew_ord'="tless_true", rls'= e_rls, calc = [], 
		srls = append_rls "srls_..Berechnung-erstSymbolisch" e_rls 
				  [Calc ("Atools.boollist2sum",
					 eval_boollist2sum "")], 
		prls = e_rls,
		crls =e_rls , nrls = norm_Rational},
"Script RechnenSymbolScript (k_::bool) (q__::bool)           \
\(u_::bool list) (s_::bool list) (o_::bool list) (l_::real) =\
\ (let t_ = Take (l_ = oben + senkrecht + unten);            \
\      sum_ = boollist2sum o_;\
\      t_ = Substitute [oben = sum_] t_;\
\      t_ = Substitute o_ t_;\
\      t_ = (Repeat (Try (Rewrite_Set norm_Rational False))) t_;\
\      sum_ = boollist2sum s_;\
\      t_ = Substitute [senkrecht = sum_] t_;\
\      t_ = Substitute s_ t_;\
\      t_ = (Repeat (Try (Rewrite_Set norm_Rational False))) t_;\
\      sum_ = boollist2sum u_;\
\      t_ = Substitute [unten = sum_] t_;\
\      t_ = Substitute u_ t_;\
\      t_ = (Repeat (Try (Rewrite_Set norm_Rational False))) t_;\
\      t_ = Substitute [k_, q__] t_\
\ in (Try (Rewrite_Set norm_Rational False)) t_)"
));

(* show_mets();
   *)
(* use"IsacKnowledge/AlgEin.ML";
   *)