(* auxiliary functions used in scripts
   author: Walther Neuper 000301
   WN0509 shift into Atools ?!? (because used also in where of models !)

   (c) copyright due to lincense terms.

remove_thy"Tools";
use_thy"Scripts/Tools";
*)


Tools =  ListG +

types (*for Descript.thy*)

  (***********************************************************************)
  (* 'fun is_dsc' in Scripts/scrtools.smlMUST contain ALL these types !!!*)
  (***********************************************************************)
  nam     (* named variables                                             *)
  una     (* unnamed variables                                           *)
  unl     (* unnamed variables of type list, elementwise input prohibited*)
  str     (* structured variables                                        *)
  toreal  (* var with undef real value: forces typing                    *)
  toreall (* var with undef real list value: forces typing               *)
  tobooll (* var with undef bool list value: forces typing               *)
  unknow  (* input without dsc in fmz=[]                                 *)
  cpy     (* UNUSED: copy-named variables
             identified by .._0, .._i .._' in pbt                        *)
  (***********************************************************************)
  (* 'fun is_dsc' in Scripts/scrtools.smlMUST contain ALL these types !!!*)
  (***********************************************************************)
  
arities

  nam, una, unl, str, toreal, toreall, tobooll, unknow, cpy :: type

consts

  UniversalList    :: bool list

(*Lhs, Rhs        :: bool => real           1.5.03 an equality DONT USE*)
  lhs, rhs        :: bool => real           (*of an equality*)
  Vars            :: 'a => real list        (*get the variables of a term *)
  matches         :: ['a, 'a] => bool

constdefs
  
  Testvar   :: "[real, 'a] => bool"  (*is a variable in a term: unused 6.5.03*)
 "Testvar v t == v mem (Vars t)"     (*by rewriting only,no Calcunused 6.5.03*)
 
end
