<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output method="html"/>

  <xsl:template match="/">
    <html>
      <body bgcolor="#FFFFFF">
        <ul>
          <xsl:apply-templates/>
        </ul>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="NODE">
    <li>      
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:text>pbl-node/</xsl:text>
        <xsl:value-of select="normalize-space(CONTENTREF)"/></xsl:attribute>
      <xsl:value-of select="ID"/>
    </xsl:element>    
    <ul>
      <xsl:apply-templates/>
    </ul>
    </li>
  </xsl:template>

  <xsl:template match="ID"/>
  <xsl:template match="CONTENTREF"/>

</xsl:stylesheet>
